Index: abi/include/abi/ipc/methods.h
===================================================================
--- abi/include/abi/ipc/methods.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ abi/include/abi/ipc/methods.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -59,4 +59,26 @@
 	IPC_M_PHONE_HUNGUP = 0,
 
+	/** Clone connection.
+	 *
+	 * The calling task clones one of its phones for the callee.
+	 *
+	 * - ARG1 - The caller sets ARG1 to the phone of the cloned connection.
+	 *        - The callee gets the new phone from ARG1.
+	 *
+	 * - on answer, the callee acknowledges the new connection by sending EOK back
+	 *   or the kernel closes it
+	 */
+	IPC_M_CONNECTION_CLONE,
+
+	/** Protocol for establishing a cloned connection.
+	 *
+	 * Through this call, the recipient learns about the new cloned connection.
+	 *
+	 * - ARG5 - the kernel sets ARG5 to contain the hash of the used phone
+	 * - on answer, the callee acknowledges the new connection by sending EOK back
+	 *   or the kernel closes it
+	 */
+	IPC_M_CLONE_ESTABLISH,
+
 	/** Protocol for initializing callback connections.
 	 *
Index: abi/include/abi/syscall.h
===================================================================
--- abi/include/abi/syscall.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ abi/include/abi/syscall.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -81,4 +81,5 @@
 	SYS_PERM_REVOKE,
 	
+	SYS_DEVICE_ASSIGN_DEVNO,
 	SYS_PHYSMEM_MAP,
 	SYS_PHYSMEM_UNMAP,
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/Makefile	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -209,4 +209,5 @@
 	generic/src/ddi/ddi.c \
 	generic/src/ddi/irq.c \
+	generic/src/ddi/device.c \
 	generic/src/debug/symtab.c \
 	generic/src/debug/stacktrace.c \
@@ -271,6 +272,8 @@
 	generic/src/ipc/sysipc.c \
 	generic/src/ipc/sysipc_ops.c \
+	generic/src/ipc/ops/clnestab.c \
 	generic/src/ipc/ops/conctmeto.c \
 	generic/src/ipc/ops/concttome.c \
+	generic/src/ipc/ops/connclone.c \
 	generic/src/ipc/ops/dataread.c \
 	generic/src/ipc/ops/datawrite.c \
@@ -283,5 +286,4 @@
 	generic/src/ipc/irq.c \
 	generic/src/ipc/event.c \
-	generic/src/cap/cap.c \
 	generic/src/security/perm.c \
 	generic/src/sysinfo/sysinfo.c \
Index: kernel/arch/arm32/src/interrupt.c
===================================================================
--- kernel/arch/arm32/src/interrupt.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/interrupt.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -38,4 +38,5 @@
 #include <arch/machine_func.h>
 #include <ddi/irq.h>
+#include <ddi/device.h>
 #include <interrupt.h>
 
Index: kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c
===================================================================
--- kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/mach/beagleboardxm/beagleboardxm.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -44,4 +44,5 @@
 #include <mm/km.h>
 #include <ddi/ddi.h>
+#include <ddi/device.h>
 
 static void bbxm_init(void);
@@ -116,4 +117,5 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
+	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = AMDM37x_GPT1_IRQ;
 	timer_irq.claim = bb_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/beaglebone/beaglebone.c
===================================================================
--- kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/mach/beaglebone/beaglebone.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -46,4 +46,5 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
+#include <ddi/device.h>
 #include <mm/km.h>
 
@@ -128,4 +129,5 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
+	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = AM335x_DMTIMER2_IRQ;
 	timer_irq.claim = bbone_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -48,4 +48,5 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
+#include <ddi/device.h>
 #include <log.h>
 
@@ -240,4 +241,5 @@
 {
 	irq_initialize(&gta02_timer_irq);
+	gta02_timer_irq.devno = device_assign_devno();
 	gta02_timer_irq.inr = GTA02_TIMER_IRQ;
 	gta02_timer_irq.claim = gta02_timer_irq_claim;
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -43,4 +43,5 @@
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
+#include <ddi/device.h>
 #include <mm/page.h>
 #include <mm/frame.h>
@@ -206,4 +207,5 @@
 {
 	irq_initialize(&icp.timer_irq);
+	icp.timer_irq.devno = device_assign_devno();
 	icp.timer_irq.inr = ICP_TIMER_IRQ;
 	icp.timer_irq.claim = icp_timer_claim;
Index: kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c
===================================================================
--- kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/arm32/src/mach/raspberrypi/raspberrypi.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -50,4 +50,5 @@
 #include <interrupt.h>
 #include <ddi/ddi.h>
+#include <ddi/device.h>
 
 #define RPI_DEFAULT_MEMORY_START	0
@@ -117,4 +118,5 @@
 	static irq_t timer_irq;
 	irq_initialize(&timer_irq);
+	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = BCM2835_TIMER1_IRQ;
 	timer_irq.claim = raspberrypi_timer_irq_claim;
Index: kernel/arch/ia32/src/drivers/i8254.c
===================================================================
--- kernel/arch/ia32/src/drivers/i8254.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/ia32/src/drivers/i8254.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -51,4 +51,5 @@
 #include <arch.h>
 #include <ddi/irq.h>
+#include <ddi/device.h>
 
 #define CLK_PORT1  ((ioport8_t *) 0x40U)
@@ -85,4 +86,5 @@
 	irq_initialize(&i8254_irq);
 	i8254_irq.preack = true;
+	i8254_irq.devno = device_assign_devno();
 	i8254_irq.inr = IRQ_CLK;
 	i8254_irq.claim = i8254_claim;
Index: kernel/arch/ia32/src/smp/apic.c
===================================================================
--- kernel/arch/ia32/src/smp/apic.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/ia32/src/smp/apic.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -47,4 +47,5 @@
 #include <arch.h>
 #include <ddi/irq.h>
+#include <ddi/device.h>
 
 #ifdef CONFIG_SMP
@@ -189,4 +190,5 @@
 	irq_initialize(&l_apic_timer_irq);
 	l_apic_timer_irq.preack = true;
+	l_apic_timer_irq.devno = device_assign_devno();
 	l_apic_timer_irq.inr = IRQ_CLK;
 	l_apic_timer_irq.claim = l_apic_timer_claim;
Index: kernel/arch/ia64/src/drivers/it.c
===================================================================
--- kernel/arch/ia64/src/drivers/it.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/ia64/src/drivers/it.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -42,4 +42,5 @@
 #include <time/clock.h>
 #include <ddi/irq.h>
+#include <ddi/device.h>
 #include <arch.h>
 
@@ -65,4 +66,5 @@
 		irq_initialize(&it_irq);
 		it_irq.inr = INTERRUPT_TIMER;
+		it_irq.devno = device_assign_devno();
 		it_irq.claim = it_claim;
 		it_irq.handler = it_interrupt;
Index: kernel/arch/mips32/src/interrupt.c
===================================================================
--- kernel/arch/mips32/src/interrupt.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/mips32/src/interrupt.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -41,4 +41,5 @@
 #include <time/clock.h>
 #include <ipc/sysipc.h>
+#include <ddi/device.h>
 
 #define IRQ_COUNT   8
@@ -174,4 +175,5 @@
 	
 	irq_initialize(&timer_irq);
+	timer_irq.devno = device_assign_devno();
 	timer_irq.inr = TIMER_IRQ;
 	timer_irq.claim = timer_claim;
@@ -184,4 +186,5 @@
 #ifdef MACHINE_msim
 	irq_initialize(&dorder_irq);
+	dorder_irq.devno = device_assign_devno();
 	dorder_irq.inr = DORDER_IRQ;
 	dorder_irq.claim = dorder_claim;
Index: kernel/arch/sparc64/src/drivers/niagara.c
===================================================================
--- kernel/arch/sparc64/src/drivers/niagara.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/arch/sparc64/src/drivers/niagara.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -39,4 +39,5 @@
 #include <console/console.h>
 #include <ddi/ddi.h>
+#include <ddi/device.h>
 #include <arch/asm.h>
 #include <arch.h>
Index: kernel/genarch/src/drivers/dsrln/dsrlnin.c
===================================================================
--- kernel/genarch/src/drivers/dsrln/dsrlnin.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/dsrln/dsrlnin.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -40,4 +40,5 @@
 #include <mm/slab.h>
 #include <arch/asm.h>
+#include <ddi/device.h>
 
 static irq_ownership_t dsrlnin_claim(irq_t *irq)
@@ -63,4 +64,5 @@
 		
 		irq_initialize(&instance->irq);
+		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = dsrlnin_claim;
Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -44,4 +44,5 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
+#include <ddi/device.h>
 #include <time/delay.h>
 
@@ -112,4 +113,5 @@
 		
 		irq_initialize(&instance->irq);
+		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = i8042_claim;
Index: kernel/genarch/src/drivers/ns16550/ns16550.c
===================================================================
--- kernel/genarch/src/drivers/ns16550/ns16550.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/ns16550/ns16550.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -41,4 +41,5 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
+#include <ddi/device.h>
 #include <str.h>
 
@@ -137,4 +138,5 @@
 		
 		irq_initialize(&instance->irq);
+		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = ns16550_claim;
Index: kernel/genarch/src/drivers/omap/uart.c
===================================================================
--- kernel/genarch/src/drivers/omap/uart.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/omap/uart.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -37,4 +37,5 @@
 #include <assert.h>
 #include <genarch/drivers/omap/uart.h>
+#include <ddi/device.h>
 #include <str.h>
 #include <mm/km.h>
@@ -160,4 +161,5 @@
 	/* Initialize IRQ */
 	irq_initialize(&uart->irq);
+	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = interrupt;
 	uart->irq.claim = omap_uart_claim;
Index: kernel/genarch/src/drivers/pl011/pl011.c
===================================================================
--- kernel/genarch/src/drivers/pl011/pl011.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/pl011/pl011.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -39,4 +39,5 @@
 #include <console/chardev.h>
 #include <console/console.h>
+#include <ddi/device.h>
 #include <arch/asm.h>
 #include <mm/slab.h>
@@ -126,4 +127,5 @@
 	/* Initialize IRQ */
 	irq_initialize(&uart->irq);
+	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = interrupt;
 	uart->irq.claim = pl011_uart_claim;
Index: kernel/genarch/src/drivers/pl050/pl050.c
===================================================================
--- kernel/genarch/src/drivers/pl050/pl050.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/pl050/pl050.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -41,4 +41,5 @@
 #include <console/chardev.h>
 #include <mm/slab.h>
+#include <ddi/device.h>
 
 #define PL050_KEY_RELEASE 0xF0
@@ -86,4 +87,5 @@
 
 		irq_initialize(&instance->irq);
+		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = pl050_claim;
Index: kernel/genarch/src/drivers/s3c24xx/uart.c
===================================================================
--- kernel/genarch/src/drivers/s3c24xx/uart.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/s3c24xx/uart.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -42,4 +42,5 @@
 #include <console/chardev.h>
 #include <console/console.h>
+#include <ddi/device.h>
 #include <arch/asm.h>
 #include <mm/slab.h>
@@ -122,4 +123,5 @@
 	/* Initialize IRQ structure. */
 	irq_initialize(&uart->irq);
+	uart->irq.devno = device_assign_devno();
 	uart->irq.inr = inr;
 	uart->irq.claim = s3c24xx_uart_claim;
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -40,4 +40,5 @@
 #include <arch/asm.h>
 #include <mm/slab.h>
+#include <ddi/device.h>
 #include <synch/spinlock.h>
 #include <mem.h>
@@ -105,4 +106,5 @@
 
 		irq_initialize(&instance->irq);
+		instance->irq.devno = device_assign_devno();
 		instance->irq.inr = inr;
 		instance->irq.claim = cuda_claim;
Index: kernel/generic/include/adt/hash_table.h
===================================================================
--- kernel/generic/include/adt/hash_table.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/adt/hash_table.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -82,5 +82,4 @@
 extern link_t *hash_table_find(hash_table_t *h, sysarg_t key[]);
 extern void hash_table_remove(hash_table_t *h, sysarg_t key[], size_t keys);
-extern void hash_table_remove_item(hash_table_t *h, link_t *item);
 
 #endif
Index: kernel/generic/include/ddi/device.h
===================================================================
--- kernel/generic/include/ddi/device.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
+++ kernel/generic/include/ddi/device.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericddi
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_DEVICE_H_
+#define KERN_DEVICE_H_
+
+#include <typedefs.h>
+
+extern devno_t device_assign_devno(void);
+extern sysarg_t sys_device_assign_devno(void);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/ddi/irq.h
===================================================================
--- kernel/generic/include/ddi/irq.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/ddi/irq.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -43,15 +43,4 @@
 #include <proc/task.h>
 #include <ipc/ipc.h>
-#include <mm/slab.h>
-
-typedef enum {
-	IRQ_HT_KEY_INR,
-	IRQ_HT_KEY_MODE
-} irq_ht_key_t;
-
-typedef enum {
-	IRQ_HT_MODE_CLAIM,
-	IRQ_HT_MODE_NO_CLAIM
-} irq_ht_mode_t;
 
 typedef enum {
@@ -81,6 +70,4 @@
 	/** When false, notifications are not sent. */
 	bool notify;
-	/** True if the structure is in irq_uspace_hash_table_table */
-	bool hashed_in;
 	/** Answerbox for notifications. */
 	answerbox_t *answerbox;
@@ -89,8 +76,14 @@
 	/** Arguments that will be sent if the IRQ is claimed. */
 	uint32_t scratch[IPC_CALL_LEN];
-	/** Top-half IRQ code. */
+	/** Top-half pseudocode. */
 	irq_code_t *code;
 	/** Counter. */
 	size_t counter;
+	
+	/**
+	 * Link between IRQs that are notifying the same answerbox. The list is
+	 * protected by the answerbox irq_lock.
+	 */
+	link_t link;
 } ipc_notif_cfg_t;
 
@@ -98,5 +91,6 @@
  *
  * If one device has multiple interrupts, there will be multiple irq_t
- * instantions.
+ * instantions with the same devno.
+ *
  */
 typedef struct irq {
@@ -118,4 +112,7 @@
 	 */
 	bool preack;
+	
+	/** Unique device number. -1 if not yet assigned. */
+	devno_t devno;
 	
 	/** Actual IRQ number. -1 if not yet assigned. */
@@ -142,6 +139,4 @@
 extern hash_table_t irq_uspace_hash_table;
 
-extern slab_cache_t *irq_slab;
-
 extern inr_t last_inr;
 
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/ipc/ipc.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -42,6 +42,6 @@
 #include <abi/proc/task.h>
 #include <typedefs.h>
-#include <mm/slab.h>
-#include <cap/cap.h>
+
+#define IPC_MAX_PHONES  64
 
 struct answerbox;
@@ -62,5 +62,5 @@
 
 /** Structure identifying phone (in TASK structure) */
-typedef struct phone {
+typedef struct {
 	mutex_t lock;
 	link_t link;
@@ -69,5 +69,4 @@
 	ipc_phone_state_t state;
 	atomic_t active_calls;
-	kobject_t *kobject;
 } phone_t;
 
@@ -95,4 +94,6 @@
 	/** Notifications from IRQ handlers. */
 	list_t irq_notifs;
+	/** IRQs with notifications to this answerbox. */
+	list_t irq_list;
 } answerbox_t;
 
@@ -169,6 +170,4 @@
 } call_t;
 
-extern slab_cache_t *phone_slab;
-
 extern answerbox_t *ipc_phone_0;
 
Index: kernel/generic/include/ipc/ipcrsc.h
===================================================================
--- kernel/generic/include/ipc/ipcrsc.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/ipc/ipcrsc.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -38,10 +38,10 @@
 #include <proc/task.h>
 #include <ipc/ipc.h>
-#include <cap/cap.h>
 
 extern call_t *get_call(sysarg_t);
-extern cap_handle_t phone_alloc(task_t *);
-extern bool phone_connect(cap_handle_t, answerbox_t *);
-extern void phone_dealloc(cap_handle_t);
+extern int phone_get(sysarg_t, phone_t **);
+extern int phone_alloc(task_t *);
+extern bool phone_connect(int, answerbox_t *);
+extern void phone_dealloc(int);
 
 #endif
Index: kernel/generic/include/ipc/irq.h
===================================================================
--- kernel/generic/include/ipc/irq.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/ipc/irq.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -47,10 +47,12 @@
 #include <adt/list.h>
 
+extern int ipc_irq_subscribe(answerbox_t *, inr_t, devno_t, sysarg_t,
+    irq_code_t *);
 
 extern irq_ownership_t ipc_irq_top_half_claim(irq_t *);
 extern void ipc_irq_top_half_handler(irq_t *);
 
-extern int ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *);
-extern int ipc_irq_unsubscribe(answerbox_t *, int);
+extern int ipc_irq_unsubscribe(answerbox_t *, inr_t, devno_t);
+extern void ipc_irq_cleanup(answerbox_t *);
 
 /*
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/ipc/sysipc.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -56,6 +56,6 @@
 extern sysarg_t sys_ipc_hangup(sysarg_t);
 
-extern sysarg_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *);
-extern sysarg_t sys_ipc_irq_unsubscribe(sysarg_t);
+extern sysarg_t sys_ipc_irq_subscribe(inr_t, devno_t, sysarg_t, irq_code_t *);
+extern sysarg_t sys_ipc_irq_unsubscribe(inr_t, devno_t);
 
 #ifdef __32_BITS__
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/proc/task.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -60,5 +60,4 @@
 #include <abi/sysinfo.h>
 #include <arch.h>
-#include <cap/cap.h>
 
 #define TASK                 THE->task
@@ -66,5 +65,4 @@
 
 struct thread;
-struct cap;
 
 /** Task structure. */
@@ -97,7 +95,4 @@
 	/** Task permissions. */
 	perm_t perms;
-
-	/** Capabilities */
-	cap_info_t *cap_info;
 	
 	/* IPC stuff */
@@ -105,4 +100,7 @@
 	/** Receiving communication endpoint */
 	answerbox_t answerbox;
+
+	/** Sending communication endpoints */
+	phone_t phones[IPC_MAX_PHONES];
 
 	/** Spinlock protecting the active_calls list. */
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/include/typedefs.h	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -49,4 +49,5 @@
 
 typedef int32_t inr_t;
+typedef int32_t devno_t;
 
 typedef volatile uint8_t ioport8_t;
Index: kernel/generic/src/adt/hash_table.c
===================================================================
--- kernel/generic/src/adt/hash_table.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/adt/hash_table.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -190,19 +190,4 @@
 }
 
-/** Remove an existing item from hash table.
- *
- * @param h     Hash table.
- * @param item  Item to remove from the hash table.
- */
-void hash_table_remove_item(hash_table_t *h, link_t *item)
-{
-	assert(h);
-	assert(h->op);
-	
-	list_remove(item);
-	if (h->op->remove_callback)
-		h->op->remove_callback(item);
-}
-
 /** @}
  */
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 91b604993517a2bdc14cfe1ede6902150ab29533)
+++ kernel/generic/src/console/kconsole.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -55,4 +55,5 @@
 #include <str.h>
 #include <sysinfo/sysinfo.h>
+#include <ddi/device.h>
 #include <symtab.h>
 #include <errno.h>
Index: kernel/generic/src/ddi/device.c
===================================================================
--- kernel/generic/src/ddi/device.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
+++ kernel/generic/src/ddi/device.c	(revision d076f1609141fd03fa25c7138c9260c1f6d19dbf)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericddi
+ * @{
+ */
+/**
+ * @file
+ * @brief Device numbers.
+ */
+
+#include <assert.h>
+#include <typedefs.h>
+#include <ddi/device.h>
+#include <atomic.h>
+#include <debug.h>
+
+static atomic_t last;
+
+/** Assign new device number.
+ *
+ * @return Unique device number.
+ */
+devno_t device_assign_devno(void)
+{
+	devno_t devno = (devno_t) atomic_postinc(&last);
+	assert(devno >= 0);
+	
+	return devno;
+}
+
+sysarg_t sys_device_assign_devno(void)
+{
+	return (sysarg_t) device_assign_devno();
+}
+
+/** @}
+ */
